1#!/bin/sh
2#
3# git-submodules.sh: add, init, update or list git submodules
4#
5# Copyright (c) 2007 Lars Hjemli
6
7dashless=$(basename "$0" | sed -e 's/-/ /')
8USAGE="[--quiet] add [-b branch] [-f|--force] [--reference <repository>] [--] <repository> [<path>]
9 or: $dashless [--quiet] status [--cached] [--recursive] [--] [<path>...]
10 or: $dashless [--quiet] init [--] [<path>...]
11 or: $dashless [--quiet] update [--init] [-N|--no-fetch] [-f|--force] [--rebase] [--reference <repository>] [--merge] [--recursive] [--] [<path>...]
12 or: $dashless [--quiet] summary [--cached|--files] [--summary-limit <n>] [commit] [--] [<path>...]
13 or: $dashless [--quiet] foreach [--recursive] <command>
14 or: $dashless [--quiet] sync [--] [<path>...]"
15OPTIONS_SPEC=
16. git-sh-setup
17. git-sh-i18n
18. git-parse-remote
19require_work_tree
20
21command=
22branch=
23force=
24reference=
25cached=
26recursive=
27init=
28files=
29nofetch=
30update=
31prefix=
32
33# Resolve relative url by appending to parent's url
34resolve_relative_url ()
35{
36 remote=$(get_default_remote)
37 remoteurl=$(git config "remote.$remote.url") ||
38 die "$(eval_gettext "remote (\$remote) does not have a url defined in .git/config")"
39 url="$1"
40 remoteurl=${remoteurl%/}
41 sep=/
42 while test -n "$url"
43 do
44 case "$url" in
45 ../*)
46 url="${url#../}"
47 case "$remoteurl" in
48 */*)
49 remoteurl="${remoteurl%/*}"
50 ;;
51 *:*)
52 remoteurl="${remoteurl%:*}"
53 sep=:
54 ;;
55 *)
56 die "$(eval_gettext "cannot strip one component off url '\$remoteurl'")"
57 ;;
58 esac
59 ;;
60 ./*)
61 url="${url#./}"
62 ;;
63 *)
64 break;;
65 esac
66 done
67 echo "$remoteurl$sep${url%/}"
68}
69
70#
71# Get submodule info for registered submodules
72# $@ = path to limit submodule list
73#
74module_list()
75{
76 git ls-files --error-unmatch --stage -- "$@" |
77 perl -e '
78 my %unmerged = ();
79 my ($null_sha1) = ("0" x 40);
80 while (<STDIN>) {
81 chomp;
82 my ($mode, $sha1, $stage, $path) =
83 /^([0-7]+) ([0-9a-f]{40}) ([0-3])\t(.*)$/;
84 next unless $mode eq "160000";
85 if ($stage ne "0") {
86 if (!$unmerged{$path}++) {
87 print "$mode $null_sha1 U\t$path\n";
88 }
89 next;
90 }
91 print "$_\n";
92 }
93 '
94}
95
96#
97# Map submodule path to submodule name
98#
99# $1 = path
100#
101module_name()
102{
103 # Do we have "submodule.<something>.path = $1" defined in .gitmodules file?
104 re=$(printf '%s\n' "$1" | sed -e 's/[].[^$\\*]/\\&/g')
105 name=$( git config -f .gitmodules --get-regexp '^submodule\..*\.path$' |
106 sed -n -e 's|^submodule\.\(.*\)\.path '"$re"'$|\1|p' )
107 test -z "$name" &&
108 die "$(eval_gettext "No submodule mapping found in .gitmodules for path '\$path'")"
109 echo "$name"
110}
111
112#
113# Clone a submodule
114#
115# Prior to calling, cmd_update checks that a possibly existing
116# path is not a git repository.
117# Likewise, cmd_add checks that path does not exist at all,
118# since it is the location of a new submodule.
119#
120module_clone()
121{
122 path=$1
123 url=$2
124 reference="$3"
125
126 if test -n "$reference"
127 then
128 git-clone "$reference" -n "$url" "$path"
129 else
130 git-clone -n "$url" "$path"
131 fi ||
132 die "$(eval_gettext "Clone of '\$url' into submodule path '\$path' failed")"
133}
134
135#
136# Add a new submodule to the working tree, .gitmodules and the index
137#
138# $@ = repo path
139#
140# optional branch is stored in global branch variable
141#
142cmd_add()
143{
144 # parse $args after "submodule ... add".
145 while test $# -ne 0
146 do
147 case "$1" in
148 -b | --branch)
149 case "$2" in '') usage ;; esac
150 branch=$2
151 shift
152 ;;
153 -f | --force)
154 force=$1
155 ;;
156 -q|--quiet)
157 GIT_QUIET=1
158 ;;
159 --reference)
160 case "$2" in '') usage ;; esac
161 reference="--reference=$2"
162 shift
163 ;;
164 --reference=*)
165 reference="$1"
166 shift
167 ;;
168 --)
169 shift
170 break
171 ;;
172 -*)
173 usage
174 ;;
175 *)
176 break
177 ;;
178 esac
179 shift
180 done
181
182 repo=$1
183 path=$2
184
185 if test -z "$path"; then
186 path=$(echo "$repo" |
187 sed -e 's|/$||' -e 's|:*/*\.git$||' -e 's|.*[/:]||g')
188 fi
189
190 if test -z "$repo" -o -z "$path"; then
191 usage
192 fi
193
194 # assure repo is absolute or relative to parent
195 case "$repo" in
196 ./*|../*)
197 # dereference source url relative to parent's url
198 realrepo=$(resolve_relative_url "$repo") || exit
199 ;;
200 *:*|/*)
201 # absolute url
202 realrepo=$repo
203 ;;
204 *)
205 die "$(eval_gettext "repo URL: '\$repo' must be absolute or begin with ./|../")"
206 ;;
207 esac
208
209 # normalize path:
210 # multiple //; leading ./; /./; /../; trailing /
211 path=$(printf '%s/\n' "$path" |
212 sed -e '
213 s|//*|/|g
214 s|^\(\./\)*||
215 s|/\./|/|g
216 :start
217 s|\([^/]*\)/\.\./||
218 tstart
219 s|/*$||
220 ')
221 git ls-files --error-unmatch "$path" > /dev/null 2>&1 &&
222 die "$(eval_gettext "'\$path' already exists in the index")"
223
224 if test -z "$force" && ! git add --dry-run --ignore-missing "$path" > /dev/null 2>&1
225 then
226 (
227 eval_gettext "The following path is ignored by one of your .gitignore files:
228\$path
229Use -f if you really want to add it." &&
230 echo
231 ) >&2
232 exit 1
233 fi
234
235 # perhaps the path exists and is already a git repo, else clone it
236 if test -e "$path"
237 then
238 if test -d "$path"/.git -o -f "$path"/.git
239 then
240 eval_gettext "Adding existing repo at '\$path' to the index"; echo
241 else
242 die "$(eval_gettext "'\$path' already exists and is not a valid git repo")"
243 fi
244
245 case "$repo" in
246 ./*|../*)
247 url=$(resolve_relative_url "$repo") || exit
248 ;;
249 *)
250 url="$repo"
251 ;;
252 esac
253 git config submodule."$path".url "$url"
254 else
255
256 module_clone "$path" "$realrepo" "$reference" || exit
257 (
258 clear_local_git_env
259 cd "$path" &&
260 # ash fails to wordsplit ${branch:+-b "$branch"...}
261 case "$branch" in
262 '') git checkout -f -q ;;
263 ?*) git checkout -f -q -B "$branch" "origin/$branch" ;;
264 esac
265 ) || die "$(eval_gettext "Unable to checkout submodule '\$path'")"
266 fi
267
268 git add $force "$path" ||
269 die "$(eval_gettext "Failed to add submodule '\$path'")"
270
271 git config -f .gitmodules submodule."$path".path "$path" &&
272 git config -f .gitmodules submodule."$path".url "$repo" &&
273 git add --force .gitmodules ||
274 die "$(eval_gettext "Failed to register submodule '\$path'")"
275}
276
277#
278# Execute an arbitrary command sequence in each checked out
279# submodule
280#
281# $@ = command to execute
282#
283cmd_foreach()
284{
285 # parse $args after "submodule ... foreach".
286 while test $# -ne 0
287 do
288 case "$1" in
289 -q|--quiet)
290 GIT_QUIET=1
291 ;;
292 --recursive)
293 recursive=1
294 ;;
295 -*)
296 usage
297 ;;
298 *)
299 break
300 ;;
301 esac
302 shift
303 done
304
305 toplevel=$(pwd)
306
307 # dup stdin so that it can be restored when running the external
308 # command in the subshell (and a recursive call to this function)
309 exec 3<&0
310
311 module_list |
312 while read mode sha1 stage path
313 do
314 if test -e "$path"/.git
315 then
316 say "$(eval_gettext "Entering '\$prefix\$path'")"
317 name=$(module_name "$path")
318 (
319 prefix="$prefix$path/"
320 clear_local_git_env
321 cd "$path" &&
322 eval "$@" &&
323 if test -n "$recursive"
324 then
325 cmd_foreach "--recursive" "$@"
326 fi
327 ) <&3 3<&- ||
328 die "$(eval_gettext "Stopping at '\$path'; script returned non-zero status.")"
329 fi
330 done
331}
332
333#
334# Register submodules in .git/config
335#
336# $@ = requested paths (default to all)
337#
338cmd_init()
339{
340 # parse $args after "submodule ... init".
341 while test $# -ne 0
342 do
343 case "$1" in
344 -q|--quiet)
345 GIT_QUIET=1
346 ;;
347 --)
348 shift
349 break
350 ;;
351 -*)
352 usage
353 ;;
354 *)
355 break
356 ;;
357 esac
358 shift
359 done
360
361 module_list "$@" |
362 while read mode sha1 stage path
363 do
364 # Skip already registered paths
365 name=$(module_name "$path") || exit
366 url=$(git config submodule."$name".url)
367 test -z "$url" || continue
368
369 url=$(git config -f .gitmodules submodule."$name".url)
370 test -z "$url" &&
371 die "$(eval_gettext "No url found for submodule path '\$path' in .gitmodules")"
372
373 # Possibly a url relative to parent
374 case "$url" in
375 ./*|../*)
376 url=$(resolve_relative_url "$url") || exit
377 ;;
378 esac
379
380 git config submodule."$name".url "$url" ||
381 die "$(eval_gettext "Failed to register url for submodule path '\$path'")"
382
383 upd="$(git config -f .gitmodules submodule."$name".update)"
384 test -z "$upd" ||
385 git config submodule."$name".update "$upd" ||
386 die "$(eval_gettext "Failed to register update mode for submodule path '\$path'")"
387
388 say "$(eval_gettext "Submodule '\$name' (\$url) registered for path '\$path'")"
389 done
390}
391
392#
393# Update each submodule path to correct revision, using clone and checkout as needed
394#
395# $@ = requested paths (default to all)
396#
397cmd_update()
398{
399 # parse $args after "submodule ... update".
400 orig_flags=
401 while test $# -ne 0
402 do
403 case "$1" in
404 -q|--quiet)
405 GIT_QUIET=1
406 ;;
407 -i|--init)
408 init=1
409 ;;
410 -N|--no-fetch)
411 nofetch=1
412 ;;
413 -f|--force)
414 force=$1
415 ;;
416 -r|--rebase)
417 update="rebase"
418 ;;
419 --reference)
420 case "$2" in '') usage ;; esac
421 reference="--reference=$2"
422 orig_flags="$orig_flags $(git rev-parse --sq-quote "$1")"
423 shift
424 ;;
425 --reference=*)
426 reference="$1"
427 ;;
428 -m|--merge)
429 update="merge"
430 ;;
431 --recursive)
432 recursive=1
433 ;;
434 --)
435 shift
436 break
437 ;;
438 -*)
439 usage
440 ;;
441 *)
442 break
443 ;;
444 esac
445 orig_flags="$orig_flags $(git rev-parse --sq-quote "$1")"
446 shift
447 done
448
449 if test -n "$init"
450 then
451 cmd_init "--" "$@" || return
452 fi
453
454 cloned_modules=
455 module_list "$@" | {
456 err=
457 while read mode sha1 stage path
458 do
459 if test "$stage" = U
460 then
461 echo >&2 "Skipping unmerged submodule $path"
462 continue
463 fi
464 name=$(module_name "$path") || exit
465 url=$(git config submodule."$name".url)
466 update_module=$(git config submodule."$name".update)
467 if test -z "$url"
468 then
469 # Only mention uninitialized submodules when its
470 # path have been specified
471 test "$#" != "0" &&
472 say "$(eval_gettext "Submodule path '\$path' not initialized
473Maybe you want to use 'update --init'?")"
474 continue
475 fi
476
477 if ! test -d "$path"/.git -o -f "$path"/.git
478 then
479 module_clone "$path" "$url" "$reference"|| exit
480 cloned_modules="$cloned_modules;$name"
481 subsha1=
482 else
483 subsha1=$(clear_local_git_env; cd "$path" &&
484 git rev-parse --verify HEAD) ||
485 die "$(eval_gettext "Unable to find current revision in submodule path '\$path'")"
486 fi
487
488 if ! test -z "$update"
489 then
490 update_module=$update
491 fi
492
493 if test "$subsha1" != "$sha1"
494 then
495 subforce=$force
496 # If we don't already have a -f flag and the submodule has never been checked out
497 if test -z "$subsha1" -a -z "$force"
498 then
499 subforce="-f"
500 fi
501
502 if test -z "$nofetch"
503 then
504 # Run fetch only if $sha1 isn't present or it
505 # is not reachable from a ref.
506 (clear_local_git_env; cd "$path" &&
507 ( (rev=$(git rev-list -n 1 $sha1 --not --all 2>/dev/null) &&
508 test -z "$rev") || git-fetch)) ||
509 die "$(eval_gettext "Unable to fetch in submodule path '\$path'")"
510 fi
511
512 # Is this something we just cloned?
513 case ";$cloned_modules;" in
514 *";$name;"*)
515 # then there is no local change to integrate
516 update_module= ;;
517 esac
518
519 must_die_on_failure=
520 case "$update_module" in
521 rebase)
522 command="git rebase"
523 die_msg="$(eval_gettext "Unable to rebase '\$sha1' in submodule path '\$path'")"
524 say_msg="$(eval_gettext "Submodule path '\$path': rebased into '\$sha1'")"
525 must_die_on_failure=yes
526 ;;
527 merge)
528 command="git merge"
529 die_msg="$(eval_gettext "Unable to merge '\$sha1' in submodule path '\$path'")"
530 say_msg="$(eval_gettext "Submodule path '\$path': merged in '\$sha1'")"
531 must_die_on_failure=yes
532 ;;
533 *)
534 command="git checkout $subforce -q"
535 die_msg="$(eval_gettext "Unable to checkout '\$sha1' in submodule path '\$path'")"
536 say_msg="$(eval_gettext "Submodule path '\$path': checked out '\$sha1'")"
537 ;;
538 esac
539
540 if (clear_local_git_env; cd "$path" && $command "$sha1")
541 then
542 say "$say_msg"
543 elif test -n "$must_die_on_failure"
544 then
545 die_with_status 2 "$die_msg"
546 else
547 err="${err};$die_msg"
548 continue
549 fi
550 fi
551
552 if test -n "$recursive"
553 then
554 (clear_local_git_env; cd "$path" && eval cmd_update "$orig_flags")
555 res=$?
556 if test $res -gt 0
557 then
558 die_msg="$(eval_gettext "Failed to recurse into submodule path '\$path'")"
559 if test $res -eq 1
560 then
561 err="${err};$die_msg"
562 continue
563 else
564 die_with_status $res "$die_msg"
565 fi
566 fi
567 fi
568 done
569
570 if test -n "$err"
571 then
572 OIFS=$IFS
573 IFS=';'
574 for e in $err
575 do
576 if test -n "$e"
577 then
578 echo >&2 "$e"
579 fi
580 done
581 IFS=$OIFS
582 exit 1
583 fi
584 }
585}
586
587set_name_rev () {
588 revname=$( (
589 clear_local_git_env
590 cd "$1" && {
591 git describe "$2" 2>/dev/null ||
592 git describe --tags "$2" 2>/dev/null ||
593 git describe --contains "$2" 2>/dev/null ||
594 git describe --all --always "$2"
595 }
596 ) )
597 test -z "$revname" || revname=" ($revname)"
598}
599#
600# Show commit summary for submodules in index or working tree
601#
602# If '--cached' is given, show summary between index and given commit,
603# or between working tree and given commit
604#
605# $@ = [commit (default 'HEAD'),] requested paths (default all)
606#
607cmd_summary() {
608 summary_limit=-1
609 for_status=
610 diff_cmd=diff-index
611
612 # parse $args after "submodule ... summary".
613 while test $# -ne 0
614 do
615 case "$1" in
616 --cached)
617 cached="$1"
618 ;;
619 --files)
620 files="$1"
621 ;;
622 --for-status)
623 for_status="$1"
624 ;;
625 -n|--summary-limit)
626 if summary_limit=$(($2 + 0)) 2>/dev/null && test "$summary_limit" = "$2"
627 then
628 :
629 else
630 usage
631 fi
632 shift
633 ;;
634 --)
635 shift
636 break
637 ;;
638 -*)
639 usage
640 ;;
641 *)
642 break
643 ;;
644 esac
645 shift
646 done
647
648 test $summary_limit = 0 && return
649
650 if rev=$(git rev-parse -q --verify --default HEAD ${1+"$1"})
651 then
652 head=$rev
653 test $# = 0 || shift
654 elif test -z "$1" -o "$1" = "HEAD"
655 then
656 # before the first commit: compare with an empty tree
657 head=$(git hash-object -w -t tree --stdin </dev/null)
658 test -z "$1" || shift
659 else
660 head="HEAD"
661 fi
662
663 if [ -n "$files" ]
664 then
665 test -n "$cached" &&
666 die "$(gettext -- "--cached cannot be used with --files")"
667 diff_cmd=diff-files
668 head=
669 fi
670
671 cd_to_toplevel
672 # Get modified modules cared by user
673 modules=$(git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- "$@" |
674 sane_egrep '^:([0-7]* )?160000' |
675 while read mod_src mod_dst sha1_src sha1_dst status name
676 do
677 # Always show modules deleted or type-changed (blob<->module)
678 test $status = D -o $status = T && echo "$name" && continue
679 # Also show added or modified modules which are checked out
680 GIT_DIR="$name/.git" git-rev-parse --git-dir >/dev/null 2>&1 &&
681 echo "$name"
682 done
683 )
684
685 test -z "$modules" && return
686
687 git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- $modules |
688 sane_egrep '^:([0-7]* )?160000' |
689 cut -c2- |
690 while read mod_src mod_dst sha1_src sha1_dst status name
691 do
692 if test -z "$cached" &&
693 test $sha1_dst = 0000000000000000000000000000000000000000
694 then
695 case "$mod_dst" in
696 160000)
697 sha1_dst=$(GIT_DIR="$name/.git" git rev-parse HEAD)
698 ;;
699 100644 | 100755 | 120000)
700 sha1_dst=$(git hash-object $name)
701 ;;
702 000000)
703 ;; # removed
704 *)
705 # unexpected type
706 (
707 eval_gettext "unexpected mode \$mod_dst" &&
708 echo
709 ) >&2
710 continue ;;
711 esac
712 fi
713 missing_src=
714 missing_dst=
715
716 test $mod_src = 160000 &&
717 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_src^0 >/dev/null &&
718 missing_src=t
719
720 test $mod_dst = 160000 &&
721 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_dst^0 >/dev/null &&
722 missing_dst=t
723
724 total_commits=
725 case "$missing_src,$missing_dst" in
726 t,)
727 errmsg="$(eval_gettext " Warn: \$name doesn't contain commit \$sha1_src")"
728 ;;
729 ,t)
730 errmsg="$(eval_gettext " Warn: \$name doesn't contain commit \$sha1_dst")"
731 ;;
732 t,t)
733 errmsg="$(eval_gettext " Warn: \$name doesn't contain commits \$sha1_src and \$sha1_dst")"
734 ;;
735 *)
736 errmsg=
737 total_commits=$(
738 if test $mod_src = 160000 -a $mod_dst = 160000
739 then
740 range="$sha1_src...$sha1_dst"
741 elif test $mod_src = 160000
742 then
743 range=$sha1_src
744 else
745 range=$sha1_dst
746 fi
747 GIT_DIR="$name/.git" \
748 git rev-list --first-parent $range -- | wc -l
749 )
750 total_commits=" ($(($total_commits + 0)))"
751 ;;
752 esac
753
754 sha1_abbr_src=$(echo $sha1_src | cut -c1-7)
755 sha1_abbr_dst=$(echo $sha1_dst | cut -c1-7)
756 if test $status = T
757 then
758 blob="$(gettext "blob")"
759 submodule="$(gettext "submodule")"
760 if test $mod_dst = 160000
761 then
762 echo "* $name $sha1_abbr_src($blob)->$sha1_abbr_dst($submodule)$total_commits:"
763 else
764 echo "* $name $sha1_abbr_src($submodule)->$sha1_abbr_dst($blob)$total_commits:"
765 fi
766 else
767 echo "* $name $sha1_abbr_src...$sha1_abbr_dst$total_commits:"
768 fi
769 if test -n "$errmsg"
770 then
771 # Don't give error msg for modification whose dst is not submodule
772 # i.e. deleted or changed to blob
773 test $mod_dst = 160000 && echo "$errmsg"
774 else
775 if test $mod_src = 160000 -a $mod_dst = 160000
776 then
777 limit=
778 test $summary_limit -gt 0 && limit="-$summary_limit"
779 GIT_DIR="$name/.git" \
780 git log $limit --pretty='format: %m %s' \
781 --first-parent $sha1_src...$sha1_dst
782 elif test $mod_dst = 160000
783 then
784 GIT_DIR="$name/.git" \
785 git log --pretty='format: > %s' -1 $sha1_dst
786 else
787 GIT_DIR="$name/.git" \
788 git log --pretty='format: < %s' -1 $sha1_src
789 fi
790 echo
791 fi
792 echo
793 done |
794 if test -n "$for_status"; then
795 if [ -n "$files" ]; then
796 gettext "# Submodules changed but not updated:"; echo
797 else
798 gettext "# Submodule changes to be committed:"; echo
799 fi
800 echo "#"
801 sed -e 's|^|# |' -e 's|^# $|#|'
802 else
803 cat
804 fi
805}
806#
807# List all submodules, prefixed with:
808# - submodule not initialized
809# + different revision checked out
810#
811# If --cached was specified the revision in the index will be printed
812# instead of the currently checked out revision.
813#
814# $@ = requested paths (default to all)
815#
816cmd_status()
817{
818 # parse $args after "submodule ... status".
819 orig_flags=
820 while test $# -ne 0
821 do
822 case "$1" in
823 -q|--quiet)
824 GIT_QUIET=1
825 ;;
826 --cached)
827 cached=1
828 ;;
829 --recursive)
830 recursive=1
831 ;;
832 --)
833 shift
834 break
835 ;;
836 -*)
837 usage
838 ;;
839 *)
840 break
841 ;;
842 esac
843 orig_flags="$orig_flags $(git rev-parse --sq-quote "$1")"
844 shift
845 done
846
847 module_list "$@" |
848 while read mode sha1 stage path
849 do
850 name=$(module_name "$path") || exit
851 url=$(git config submodule."$name".url)
852 displaypath="$prefix$path"
853 if test "$stage" = U
854 then
855 say "U$sha1 $displaypath"
856 continue
857 fi
858 if test -z "$url" || ! test -d "$path"/.git -o -f "$path"/.git
859 then
860 say "-$sha1 $displaypath"
861 continue;
862 fi
863 set_name_rev "$path" "$sha1"
864 if git diff-files --ignore-submodules=dirty --quiet -- "$path"
865 then
866 say " $sha1 $displaypath$revname"
867 else
868 if test -z "$cached"
869 then
870 sha1=$(clear_local_git_env; cd "$path" && git rev-parse --verify HEAD)
871 set_name_rev "$path" "$sha1"
872 fi
873 say "+$sha1 $displaypath$revname"
874 fi
875
876 if test -n "$recursive"
877 then
878 (
879 prefix="$displaypath/"
880 clear_local_git_env
881 cd "$path" &&
882 eval cmd_status "$orig_args"
883 ) ||
884 die "$(eval_gettext "Failed to recurse into submodule path '\$path'")"
885 fi
886 done
887}
888#
889# Sync remote urls for submodules
890# This makes the value for remote.$remote.url match the value
891# specified in .gitmodules.
892#
893cmd_sync()
894{
895 while test $# -ne 0
896 do
897 case "$1" in
898 -q|--quiet)
899 GIT_QUIET=1
900 shift
901 ;;
902 --)
903 shift
904 break
905 ;;
906 -*)
907 usage
908 ;;
909 *)
910 break
911 ;;
912 esac
913 done
914 cd_to_toplevel
915 module_list "$@" |
916 while read mode sha1 stage path
917 do
918 name=$(module_name "$path")
919 url=$(git config -f .gitmodules --get submodule."$name".url)
920
921 # Possibly a url relative to parent
922 case "$url" in
923 ./*|../*)
924 url=$(resolve_relative_url "$url") || exit
925 ;;
926 esac
927
928 say "$(eval_gettext "Synchronizing submodule url for '\$name'")"
929 git config submodule."$name".url "$url"
930
931 if test -e "$path"/.git
932 then
933 (
934 clear_local_git_env
935 cd "$path"
936 remote=$(get_default_remote)
937 git config remote."$remote".url "$url"
938 )
939 fi
940 done
941}
942
943# This loop parses the command line arguments to find the
944# subcommand name to dispatch. Parsing of the subcommand specific
945# options are primarily done by the subcommand implementations.
946# Subcommand specific options such as --branch and --cached are
947# parsed here as well, for backward compatibility.
948
949while test $# != 0 && test -z "$command"
950do
951 case "$1" in
952 add | foreach | init | update | status | summary | sync)
953 command=$1
954 ;;
955 -q|--quiet)
956 GIT_QUIET=1
957 ;;
958 -b|--branch)
959 case "$2" in
960 '')
961 usage
962 ;;
963 esac
964 branch="$2"; shift
965 ;;
966 --cached)
967 cached="$1"
968 ;;
969 --)
970 break
971 ;;
972 -*)
973 usage
974 ;;
975 *)
976 break
977 ;;
978 esac
979 shift
980done
981
982# No command word defaults to "status"
983test -n "$command" || command=status
984
985# "-b branch" is accepted only by "add"
986if test -n "$branch" && test "$command" != add
987then
988 usage
989fi
990
991# "--cached" is accepted only by "status" and "summary"
992if test -n "$cached" && test "$command" != status -a "$command" != summary
993then
994 usage
995fi
996
997"cmd_$command" "$@"